


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/examples/ntlmrelayx/servers/socksplugins/http.py: 11%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/examples/ntlmrelayx/servers/socksplugins/http.py</b> :
            <span class="pc_cov">11%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            122 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">17 run</span>
            <span class="mis shortkey_m button_toggle_mis">105 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="stm run hide_run"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="stm run hide_run"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="pln"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="pln"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="pln"><a href="#n30">30</a></p>
<p id="n31" class="stm run hide_run"><a href="#n31">31</a></p>
<p id="n32" class="stm mis"><a href="#n32">32</a></p>
<p id="n33" class="stm mis"><a href="#n33">33</a></p>
<p id="n34" class="pln"><a href="#n34">34</a></p>
<p id="n35" class="stm run hide_run"><a href="#n35">35</a></p>
<p id="n36" class="pln"><a href="#n36">36</a></p>
<p id="n37" class="stm mis"><a href="#n37">37</a></p>
<p id="n38" class="pln"><a href="#n38">38</a></p>
<p id="n39" class="stm run hide_run"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="pln"><a href="#n41">41</a></p>
<p id="n42" class="stm run hide_run"><a href="#n42">42</a></p>
<p id="n43" class="pln"><a href="#n43">43</a></p>
<p id="n44" class="stm mis"><a href="#n44">44</a></p>
<p id="n45" class="pln"><a href="#n45">45</a></p>
<p id="n46" class="stm mis"><a href="#n46">46</a></p>
<p id="n47" class="stm mis"><a href="#n47">47</a></p>
<p id="n48" class="stm mis"><a href="#n48">48</a></p>
<p id="n49" class="stm mis"><a href="#n49">49</a></p>
<p id="n50" class="stm mis"><a href="#n50">50</a></p>
<p id="n51" class="stm mis"><a href="#n51">51</a></p>
<p id="n52" class="stm mis"><a href="#n52">52</a></p>
<p id="n53" class="stm mis"><a href="#n53">53</a></p>
<p id="n54" class="pln"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="stm mis"><a href="#n56">56</a></p>
<p id="n57" class="pln"><a href="#n57">57</a></p>
<p id="n58" class="pln"><a href="#n58">58</a></p>
<p id="n59" class="pln"><a href="#n59">59</a></p>
<p id="n60" class="pln"><a href="#n60">60</a></p>
<p id="n61" class="stm mis"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="pln"><a href="#n63">63</a></p>
<p id="n64" class="stm mis"><a href="#n64">64</a></p>
<p id="n65" class="pln"><a href="#n65">65</a></p>
<p id="n66" class="stm mis"><a href="#n66">66</a></p>
<p id="n67" class="stm mis"><a href="#n67">67</a></p>
<p id="n68" class="pln"><a href="#n68">68</a></p>
<p id="n69" class="stm mis"><a href="#n69">69</a></p>
<p id="n70" class="pln"><a href="#n70">70</a></p>
<p id="n71" class="stm mis"><a href="#n71">71</a></p>
<p id="n72" class="pln"><a href="#n72">72</a></p>
<p id="n73" class="stm mis"><a href="#n73">73</a></p>
<p id="n74" class="pln"><a href="#n74">74</a></p>
<p id="n75" class="stm mis"><a href="#n75">75</a></p>
<p id="n76" class="pln"><a href="#n76">76</a></p>
<p id="n77" class="stm mis"><a href="#n77">77</a></p>
<p id="n78" class="pln"><a href="#n78">78</a></p>
<p id="n79" class="stm mis"><a href="#n79">79</a></p>
<p id="n80" class="pln"><a href="#n80">80</a></p>
<p id="n81" class="stm mis"><a href="#n81">81</a></p>
<p id="n82" class="stm mis"><a href="#n82">82</a></p>
<p id="n83" class="stm mis"><a href="#n83">83</a></p>
<p id="n84" class="stm mis"><a href="#n84">84</a></p>
<p id="n85" class="pln"><a href="#n85">85</a></p>
<p id="n86" class="pln"><a href="#n86">86</a></p>
<p id="n87" class="pln"><a href="#n87">87</a></p>
<p id="n88" class="pln"><a href="#n88">88</a></p>
<p id="n89" class="stm mis"><a href="#n89">89</a></p>
<p id="n90" class="pln"><a href="#n90">90</a></p>
<p id="n91" class="stm mis"><a href="#n91">91</a></p>
<p id="n92" class="stm mis"><a href="#n92">92</a></p>
<p id="n93" class="pln"><a href="#n93">93</a></p>
<p id="n94" class="stm mis"><a href="#n94">94</a></p>
<p id="n95" class="stm mis"><a href="#n95">95</a></p>
<p id="n96" class="pln"><a href="#n96">96</a></p>
<p id="n97" class="stm run hide_run"><a href="#n97">97</a></p>
<p id="n98" class="pln"><a href="#n98">98</a></p>
<p id="n99" class="pln"><a href="#n99">99</a></p>
<p id="n100" class="stm mis"><a href="#n100">100</a></p>
<p id="n101" class="stm mis"><a href="#n101">101</a></p>
<p id="n102" class="stm mis"><a href="#n102">102</a></p>
<p id="n103" class="stm mis"><a href="#n103">103</a></p>
<p id="n104" class="pln"><a href="#n104">104</a></p>
<p id="n105" class="stm run hide_run"><a href="#n105">105</a></p>
<p id="n106" class="stm mis"><a href="#n106">106</a></p>
<p id="n107" class="stm mis"><a href="#n107">107</a></p>
<p id="n108" class="stm mis"><a href="#n108">108</a></p>
<p id="n109" class="stm mis"><a href="#n109">109</a></p>
<p id="n110" class="stm mis"><a href="#n110">110</a></p>
<p id="n111" class="stm mis"><a href="#n111">111</a></p>
<p id="n112" class="pln"><a href="#n112">112</a></p>
<p id="n113" class="stm mis"><a href="#n113">113</a></p>
<p id="n114" class="stm mis"><a href="#n114">114</a></p>
<p id="n115" class="stm mis"><a href="#n115">115</a></p>
<p id="n116" class="stm mis"><a href="#n116">116</a></p>
<p id="n117" class="stm mis"><a href="#n117">117</a></p>
<p id="n118" class="stm mis"><a href="#n118">118</a></p>
<p id="n119" class="stm mis"><a href="#n119">119</a></p>
<p id="n120" class="stm mis"><a href="#n120">120</a></p>
<p id="n121" class="pln"><a href="#n121">121</a></p>
<p id="n122" class="stm mis"><a href="#n122">122</a></p>
<p id="n123" class="stm mis"><a href="#n123">123</a></p>
<p id="n124" class="pln"><a href="#n124">124</a></p>
<p id="n125" class="pln"><a href="#n125">125</a></p>
<p id="n126" class="stm mis"><a href="#n126">126</a></p>
<p id="n127" class="stm mis"><a href="#n127">127</a></p>
<p id="n128" class="pln"><a href="#n128">128</a></p>
<p id="n129" class="stm mis"><a href="#n129">129</a></p>
<p id="n130" class="pln"><a href="#n130">130</a></p>
<p id="n131" class="stm run hide_run"><a href="#n131">131</a></p>
<p id="n132" class="stm mis"><a href="#n132">132</a></p>
<p id="n133" class="pln"><a href="#n133">133</a></p>
<p id="n134" class="stm mis"><a href="#n134">134</a></p>
<p id="n135" class="pln"><a href="#n135">135</a></p>
<p id="n136" class="stm mis"><a href="#n136">136</a></p>
<p id="n137" class="pln"><a href="#n137">137</a></p>
<p id="n138" class="stm mis"><a href="#n138">138</a></p>
<p id="n139" class="stm mis"><a href="#n139">139</a></p>
<p id="n140" class="pln"><a href="#n140">140</a></p>
<p id="n141" class="stm mis"><a href="#n141">141</a></p>
<p id="n142" class="stm mis"><a href="#n142">142</a></p>
<p id="n143" class="pln"><a href="#n143">143</a></p>
<p id="n144" class="stm mis"><a href="#n144">144</a></p>
<p id="n145" class="stm mis"><a href="#n145">145</a></p>
<p id="n146" class="stm mis"><a href="#n146">146</a></p>
<p id="n147" class="stm mis"><a href="#n147">147</a></p>
<p id="n148" class="stm mis"><a href="#n148">148</a></p>
<p id="n149" class="stm mis"><a href="#n149">149</a></p>
<p id="n150" class="stm mis"><a href="#n150">150</a></p>
<p id="n151" class="stm mis"><a href="#n151">151</a></p>
<p id="n152" class="stm mis"><a href="#n152">152</a></p>
<p id="n153" class="stm mis"><a href="#n153">153</a></p>
<p id="n154" class="pln"><a href="#n154">154</a></p>
<p id="n155" class="stm run hide_run"><a href="#n155">155</a></p>
<p id="n156" class="pln"><a href="#n156">156</a></p>
<p id="n157" class="stm mis"><a href="#n157">157</a></p>
<p id="n158" class="stm mis"><a href="#n158">158</a></p>
<p id="n159" class="pln"><a href="#n159">159</a></p>
<p id="n160" class="stm mis"><a href="#n160">160</a></p>
<p id="n161" class="stm mis"><a href="#n161">161</a></p>
<p id="n162" class="pln"><a href="#n162">162</a></p>
<p id="n163" class="stm mis"><a href="#n163">163</a></p>
<p id="n164" class="stm mis"><a href="#n164">164</a></p>
<p id="n165" class="pln"><a href="#n165">165</a></p>
<p id="n166" class="stm mis"><a href="#n166">166</a></p>
<p id="n167" class="stm mis"><a href="#n167">167</a></p>
<p id="n168" class="stm mis"><a href="#n168">168</a></p>
<p id="n169" class="pln"><a href="#n169">169</a></p>
<p id="n170" class="stm mis"><a href="#n170">170</a></p>
<p id="n171" class="pln"><a href="#n171">171</a></p>
<p id="n172" class="stm mis"><a href="#n172">172</a></p>
<p id="n173" class="stm mis"><a href="#n173">173</a></p>
<p id="n174" class="stm mis"><a href="#n174">174</a></p>
<p id="n175" class="pln"><a href="#n175">175</a></p>
<p id="n176" class="pln"><a href="#n176">176</a></p>
<p id="n177" class="stm mis"><a href="#n177">177</a></p>
<p id="n178" class="stm mis"><a href="#n178">178</a></p>
<p id="n179" class="stm mis"><a href="#n179">179</a></p>
<p id="n180" class="stm mis"><a href="#n180">180</a></p>
<p id="n181" class="stm mis"><a href="#n181">181</a></p>
<p id="n182" class="stm mis"><a href="#n182">182</a></p>
<p id="n183" class="stm mis"><a href="#n183">183</a></p>
<p id="n184" class="stm mis"><a href="#n184">184</a></p>
<p id="n185" class="stm mis"><a href="#n185">185</a></p>
<p id="n186" class="stm mis"><a href="#n186">186</a></p>
<p id="n187" class="pln"><a href="#n187">187</a></p>
<p id="n188" class="pln"><a href="#n188">188</a></p>
<p id="n189" class="stm mis"><a href="#n189">189</a></p>
<p id="n190" class="stm mis"><a href="#n190">190</a></p>
<p id="n191" class="pln"><a href="#n191">191</a></p>
<p id="n192" class="pln"><a href="#n192">192</a></p>
<p id="n193" class="stm run hide_run"><a href="#n193">193</a></p>
<p id="n194" class="stm mis"><a href="#n194">194</a></p>
<p id="n195" class="stm mis"><a href="#n195">195</a></p>
<p id="n196" class="pln"><a href="#n196">196</a></p>
<p id="n197" class="stm mis"><a href="#n197">197</a></p>
<p id="n198" class="stm mis"><a href="#n198">198</a></p>
<p id="n199" class="pln"><a href="#n199">199</a></p>
<p id="n200" class="stm mis"><a href="#n200">200</a></p>
<p id="n201" class="stm mis"><a href="#n201">201</a></p>
<p id="n202" class="pln"><a href="#n202">202</a></p>
<p id="n203" class="stm mis"><a href="#n203">203</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># A Socks Proxy for the HTTP Protocol</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Author:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#  Dirk-jan Mollema (@_dirkjan) / Fox-IT (https://www.fox-it.com)</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com">#  A simple SOCKS server that proxies a connection to relayed HTTP connections</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com"># ToDo:</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="stm run hide_run"><span class="key">import</span> <span class="nam">base64</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">LOG</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">examples</span><span class="op">.</span><span class="nam">ntlmrelayx</span><span class="op">.</span><span class="nam">servers</span><span class="op">.</span><span class="nam">socksserver</span> <span class="key">import</span> <span class="nam">SocksRelay</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="com"># Besides using this base class you need to define one global variable when</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="pln"><span class="com"># writing a plugin:</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run"><span class="nam">PLUGIN_CLASS</span> <span class="op">=</span> <span class="str">"HTTPSocksRelay"</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run"><span class="nam">EOL</span> <span class="op">=</span> <span class="str">'\r\n'</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run"><span class="key">class</span> <span class="nam">HTTPSocksRelay</span><span class="op">(</span><span class="nam">SocksRelay</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run">    <span class="nam">PLUGIN_NAME</span> <span class="op">=</span> <span class="str">'HTTP Socks Plugin'</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run">    <span class="nam">PLUGIN_SCHEME</span> <span class="op">=</span> <span class="str">'HTTP'</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">targetHost</span><span class="op">,</span> <span class="nam">targetPort</span><span class="op">,</span> <span class="nam">socksSocket</span><span class="op">,</span> <span class="nam">activeRelays</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm mis">        <span class="nam">SocksRelay</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">targetHost</span><span class="op">,</span> <span class="nam">targetPort</span><span class="op">,</span> <span class="nam">socksSocket</span><span class="op">,</span> <span class="nam">activeRelays</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span> <span class="op">=</span> <span class="num">8192</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm run hide_run">    <span class="op">@</span><span class="nam">staticmethod</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="pln">    <span class="key">def</span> <span class="nam">getProtocolPort</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm mis">        <span class="key">return</span> <span class="num">80</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm run hide_run">    <span class="key">def</span> <span class="nam">initConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">        <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm run hide_run">    <span class="key">def</span> <span class="nam">skipAuthentication</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="pln">        <span class="com"># See if the user provided authentication</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm mis">        <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="pln">        <span class="com"># Get headers from data</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm mis">        <span class="nam">headerDict</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">getHeaders</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm mis">            <span class="nam">creds</span> <span class="op">=</span> <span class="nam">headerDict</span><span class="op">[</span><span class="str">'authorization'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm mis">            <span class="key">if</span> <span class="str">'Basic'</span> <span class="key">not</span> <span class="key">in</span> <span class="nam">creds</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm mis">                <span class="key">raise</span> <span class="nam">KeyError</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm mis">            <span class="nam">basicAuth</span> <span class="op">=</span> <span class="nam">base64</span><span class="op">.</span><span class="nam">b64decode</span><span class="op">(</span><span class="nam">creds</span><span class="op">[</span><span class="num">6</span><span class="op">:</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">username</span> <span class="op">=</span> <span class="nam">basicAuth</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">':'</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">.</span><span class="nam">upper</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm mis">            <span class="key">if</span> <span class="str">'@'</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="pln">                <span class="com"># Workaround for clients which specify users with the full FQDN</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln">                <span class="com"># such as ruler</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm mis">                <span class="nam">user</span><span class="op">,</span> <span class="nam">domain</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">'@'</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="pln">                <span class="com"># Currently we only use the first part of the FQDN</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="pln">                <span class="com"># this might break stuff on tools that do use an FQDN</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="pln">                <span class="com"># where the domain NETBIOS name is not equal to the part</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="pln">                <span class="com"># before the first .</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">username</span> <span class="op">=</span> <span class="str">'%s/%s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">domain</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">'.'</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">,</span> <span class="nam">user</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t63" class="pln">            <span class="com"># Check if we have a connection for the user</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm mis">            <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">username</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">activeRelays</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="pln">                <span class="com"># Check the connection is not inUse</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm mis">                <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">activeRelays</span><span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">]</span><span class="op">[</span><span class="str">'inUse'</span><span class="op">]</span> <span class="key">is</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm mis">                    <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">'HTTP: Connection for %s@%s(%s) is being used at the moment!'</span> <span class="op">%</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="pln">                        <span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetHost</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetPort</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm mis">                    <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="pln">                <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm mis">                    <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'HTTP: Proxying client session for %s@%s(%s)'</span> <span class="op">%</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="pln">                        <span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetHost</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetPort</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm mis">                    <span class="nam">self</span><span class="op">.</span><span class="nam">session</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">activeRelays</span><span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">]</span><span class="op">[</span><span class="str">'protocolClient'</span><span class="op">]</span><span class="op">.</span><span class="nam">session</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">'HTTP: No session for %s@%s(%s) available'</span> <span class="op">%</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="pln">                    <span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetHost</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetPort</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm mis">                <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t79" class="stm mis">        <span class="key">except</span> <span class="nam">KeyError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="pln">            <span class="com"># User didn't provide authentication yet, prompt for it</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'No authentication provided, prompting for basic authentication'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm mis">            <span class="nam">reply</span> <span class="op">=</span> <span class="op">[</span><span class="str">'HTTP/1.1 401 Unauthorized'</span><span class="op">,</span><span class="str">'WWW-Authenticate: Basic realm="ntlmrelayx - provide a DOMAIN/username"'</span><span class="op">,</span><span class="str">'Connection: close'</span><span class="op">,</span><span class="str">''</span><span class="op">,</span><span class="str">''</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">EOL</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">reply</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm mis">            <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t86" class="pln">        <span class="com"># When we are here, we have a session</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="pln">        <span class="com"># Point our socket to the sock attribute of HTTPConnection</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="pln">        <span class="com"># (contained in the session), which contains the socket</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">sock</span><span class="strut">&nbsp;</span></p>
<p id="t90" class="pln">        <span class="com"># Send the initial request to the server</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="stm mis">        <span class="nam">tosend</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">prepareRequest</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">tosend</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="pln">        <span class="com"># Send the response back to the client</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">transferResponse</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="stm mis">        <span class="key">return</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t97" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getHeaders</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="pln">        <span class="com"># Get the headers from the request, ignore first "header"</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="pln">        <span class="com"># since this is the HTTP method, identifier, version</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="stm mis">        <span class="nam">headerSize</span> <span class="op">=</span> <span class="nam">data</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="nam">EOL</span><span class="op">+</span><span class="nam">EOL</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t101" class="stm mis">        <span class="nam">headers</span> <span class="op">=</span> <span class="nam">data</span><span class="op">[</span><span class="op">:</span><span class="nam">headerSize</span><span class="op">]</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="nam">EOL</span><span class="op">)</span><span class="op">[</span><span class="num">1</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm mis">        <span class="nam">headerDict</span> <span class="op">=</span> <span class="op">{</span><span class="nam">hdrKey</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">':'</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">.</span><span class="nam">lower</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="nam">hdrKey</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">':'</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="op">[</span><span class="num">1</span><span class="op">:</span><span class="op">]</span> <span class="key">for</span> <span class="nam">hdrKey</span> <span class="key">in</span> <span class="nam">headers</span><span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="stm mis">        <span class="key">return</span> <span class="nam">headerDict</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t105" class="stm run hide_run">    <span class="key">def</span> <span class="nam">transferResponse</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="stm mis">        <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="stm mis">        <span class="nam">headerSize</span> <span class="op">=</span> <span class="nam">data</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="nam">EOL</span><span class="op">+</span><span class="nam">EOL</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm mis">        <span class="nam">headers</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">getHeaders</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="stm mis">            <span class="nam">bodySize</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">headers</span><span class="op">[</span><span class="str">'content-length'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="stm mis">            <span class="nam">readSize</span> <span class="op">=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="pln">            <span class="com"># Make sure we send the entire response, but don't keep it in memory</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="stm mis">            <span class="key">while</span> <span class="nam">readSize</span> <span class="op">&lt;</span> <span class="nam">bodySize</span> <span class="op">+</span> <span class="nam">headerSize</span> <span class="op">+</span> <span class="num">4</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="stm mis">                <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="stm mis">                <span class="nam">readSize</span> <span class="op">+=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="stm mis">        <span class="key">except</span> <span class="nam">KeyError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="stm mis">            <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm mis">                <span class="key">if</span> <span class="nam">headers</span><span class="op">[</span><span class="str">'transfer-encoding'</span><span class="op">]</span> <span class="op">==</span> <span class="str">'chunked'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="pln">                    <span class="com"># Chunked transfer-encoding, bah</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="stm mis">                    <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'Server sent chunked encoding - transferring'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm mis">                    <span class="nam">self</span><span class="op">.</span><span class="nam">transferChunked</span><span class="op">(</span><span class="nam">data</span><span class="op">,</span> <span class="nam">headers</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="pln">                <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="pln">                    <span class="com"># No body in the response, send as-is</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="stm mis">                    <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="stm mis">            <span class="key">except</span> <span class="nam">KeyError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="pln">                <span class="com"># No body in the response, send as-is</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t130" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t131" class="stm run hide_run">    <span class="key">def</span> <span class="nam">transferChunked</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">headers</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="stm mis">        <span class="nam">headerSize</span> <span class="op">=</span> <span class="nam">data</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="nam">EOL</span><span class="op">+</span><span class="nam">EOL</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t134" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">data</span><span class="op">[</span><span class="op">:</span><span class="nam">headerSize</span> <span class="op">+</span> <span class="num">4</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t135" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t136" class="stm mis">        <span class="nam">body</span> <span class="op">=</span> <span class="nam">data</span><span class="op">[</span><span class="nam">headerSize</span> <span class="op">+</span> <span class="num">4</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="pln">        <span class="com"># Size of the chunk</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="stm mis">        <span class="nam">datasize</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">body</span><span class="op">[</span><span class="op">:</span><span class="nam">body</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="nam">EOL</span><span class="op">)</span><span class="op">]</span><span class="op">,</span> <span class="num">16</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t139" class="stm mis">        <span class="key">while</span> <span class="nam">datasize</span> <span class="op">></span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t140" class="pln">            <span class="com"># Size of the total body</span><span class="strut">&nbsp;</span></p>
<p id="t141" class="stm mis">            <span class="nam">bodySize</span> <span class="op">=</span> <span class="nam">body</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="nam">EOL</span><span class="op">)</span> <span class="op">+</span> <span class="num">2</span> <span class="op">+</span> <span class="nam">datasize</span> <span class="op">+</span> <span class="num">2</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="stm mis">            <span class="nam">readSize</span> <span class="op">=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">body</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="pln">            <span class="com"># Make sure we send the entire response, but don't keep it in memory</span><span class="strut">&nbsp;</span></p>
<p id="t144" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">body</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t145" class="stm mis">            <span class="key">while</span> <span class="nam">readSize</span> <span class="op">&lt;</span> <span class="nam">bodySize</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t146" class="stm mis">                <span class="nam">maxReadSize</span> <span class="op">=</span> <span class="nam">bodySize</span> <span class="op">-</span> <span class="nam">readSize</span><span class="strut">&nbsp;</span></p>
<p id="t147" class="stm mis">                <span class="nam">body</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">min</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">,</span> <span class="nam">maxReadSize</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t148" class="stm mis">                <span class="nam">readSize</span> <span class="op">+=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">body</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">body</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t150" class="stm mis">            <span class="nam">body</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t151" class="stm mis">            <span class="nam">datasize</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">body</span><span class="op">[</span><span class="op">:</span><span class="nam">body</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="nam">EOL</span><span class="op">)</span><span class="op">]</span><span class="op">,</span> <span class="num">16</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t152" class="stm mis">        <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'Last chunk received - exiting chunked transfer'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">body</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t154" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t155" class="stm run hide_run">    <span class="key">def</span> <span class="nam">prepareRequest</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t156" class="pln">        <span class="com"># Parse the HTTP data, removing headers that break stuff</span><span class="strut">&nbsp;</span></p>
<p id="t157" class="stm mis">        <span class="nam">response</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t158" class="stm mis">        <span class="key">for</span> <span class="nam">part</span> <span class="key">in</span> <span class="nam">data</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="nam">EOL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t159" class="pln">            <span class="com"># This means end of headers, stop parsing here</span><span class="strut">&nbsp;</span></p>
<p id="t160" class="stm mis">            <span class="key">if</span> <span class="nam">part</span> <span class="op">==</span> <span class="str">''</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t161" class="stm mis">                <span class="key">break</span><span class="strut">&nbsp;</span></p>
<p id="t162" class="pln">            <span class="com"># Remove the Basic authentication header</span><span class="strut">&nbsp;</span></p>
<p id="t163" class="stm mis">            <span class="key">if</span> <span class="str">'authorization'</span> <span class="key">in</span> <span class="nam">part</span><span class="op">.</span><span class="nam">lower</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t164" class="stm mis">                <span class="key">continue</span><span class="strut">&nbsp;</span></p>
<p id="t165" class="pln">            <span class="com"># Don't close the connection</span><span class="strut">&nbsp;</span></p>
<p id="t166" class="stm mis">            <span class="key">if</span> <span class="str">'connection: close'</span> <span class="key">in</span> <span class="nam">part</span><span class="op">.</span><span class="nam">lower</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t167" class="stm mis">                <span class="nam">response</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="str">'Connection: Keep-Alive'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t168" class="stm mis">                <span class="key">continue</span><span class="strut">&nbsp;</span></p>
<p id="t169" class="pln">            <span class="com"># If we are here it means we want to keep the header</span><span class="strut">&nbsp;</span></p>
<p id="t170" class="stm mis">            <span class="nam">response</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">part</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t171" class="pln">        <span class="com"># Append the body</span><span class="strut">&nbsp;</span></p>
<p id="t172" class="stm mis">        <span class="nam">response</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="str">''</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t173" class="stm mis">        <span class="nam">response</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">data</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="nam">EOL</span><span class="op">+</span><span class="nam">EOL</span><span class="op">)</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t174" class="stm mis">        <span class="nam">senddata</span> <span class="op">=</span> <span class="nam">EOL</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">response</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t175" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t176" class="pln">        <span class="com"># Check if the body is larger than 1 packet</span><span class="strut">&nbsp;</span></p>
<p id="t177" class="stm mis">        <span class="nam">headerSize</span> <span class="op">=</span> <span class="nam">data</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="nam">EOL</span><span class="op">+</span><span class="nam">EOL</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t178" class="stm mis">        <span class="nam">headers</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">getHeaders</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t179" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t180" class="stm mis">            <span class="nam">bodySize</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">headers</span><span class="op">[</span><span class="str">'content-length'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t181" class="stm mis">            <span class="nam">readSize</span> <span class="op">=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t182" class="stm mis">            <span class="key">while</span> <span class="nam">readSize</span> <span class="op">&lt;</span> <span class="nam">bodySize</span> <span class="op">+</span> <span class="nam">headerSize</span> <span class="op">+</span> <span class="num">4</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t183" class="stm mis">                <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t184" class="stm mis">                <span class="nam">readSize</span> <span class="op">+=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t185" class="stm mis">                <span class="nam">senddata</span> <span class="op">+=</span> <span class="nam">data</span><span class="strut">&nbsp;</span></p>
<p id="t186" class="stm mis">        <span class="key">except</span> <span class="nam">KeyError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t187" class="pln">            <span class="com"># No body, could be a simple GET or a POST without body</span><span class="strut">&nbsp;</span></p>
<p id="t188" class="pln">            <span class="com"># no need to check if we already have the full packet</span><span class="strut">&nbsp;</span></p>
<p id="t189" class="stm mis">            <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t190" class="stm mis">        <span class="key">return</span> <span class="nam">senddata</span><span class="strut">&nbsp;</span></p>
<p id="t191" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t192" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t193" class="stm run hide_run">    <span class="key">def</span> <span class="nam">tunnelConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t194" class="stm mis">        <span class="key">while</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t195" class="stm mis">            <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t196" class="pln">            <span class="com"># If this returns with an empty string, it means the socket was closed</span><span class="strut">&nbsp;</span></p>
<p id="t197" class="stm mis">            <span class="key">if</span> <span class="nam">data</span> <span class="op">==</span> <span class="str">''</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t198" class="stm mis">                <span class="key">return</span><span class="strut">&nbsp;</span></p>
<p id="t199" class="pln">            <span class="com"># Pass the request to the server</span><span class="strut">&nbsp;</span></p>
<p id="t200" class="stm mis">            <span class="nam">tosend</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">prepareRequest</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t201" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">tosend</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t202" class="pln">            <span class="com"># Send the response back to the client</span><span class="strut">&nbsp;</span></p>
<p id="t203" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">transferResponse</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
